"use strict";const winston=require("winston"),{createLogger:createLogger,format:format,transports:transports}=winston,{combine:combine,timestamp:timestamp,colorize:colorize,printf:printf}=format,WinstonDailyRotateFile=require("winston-daily-rotate-file"),LOGLEVEL={error:0,warn:1,info:2,verbose:3,debug:4,silly:5},LOGFILEROTATE={monthly:0,weekly:1,daily:2,hourly:3,minutely:4},DEFAULTISFILEROTATE=!1,DEFAULTFILEROTATETYPE=LOGFILEROTATE.daily,DEFAULTFILEROTATEMAXSIZE="1g",converseLeveValue=function(e){let l=0;switch(e){case"error":l=LOGLEVEL.error;break;case"warn":l=LOGLEVEL.warn;break;case"info":l=LOGLEVEL.info;break;case"verbose":l=LOGLEVEL.verbose;break;case"debug":l=LOGLEVEL.debug;break;case"silly":l=LOGLEVEL.silly}return l};function internalLevel(e){let l="error";switch(e){case LOGLEVEL.error:l="error";break;case LOGLEVEL.warn:l="warn";break;case LOGLEVEL.info:l="info";break;case LOGLEVEL.verbose:l="verbose";break;case LOGLEVEL.debug:l="debug";break;case LOGLEVEL.silly:l="silly"}return l}function logFileRotateDatePattern(e){let l=null;if(null===e||void 0===e)return l;switch(e){case LOGFILEROTATE.monthly:l="YYYY-MM";break;case LOGFILEROTATE.weekly:l="YYYY-[W]WW";break;case LOGFILEROTATE.daily:l="YYYY-MM-DD";break;case LOGFILEROTATE.hourly:l="YYYY-MM-DDTHH";break;case LOGFILEROTATE.minutely:l="YYYY-MM-DDTHH_mm"}return l}function fileTransport(e,l,t,o){if(l){let l="./%DATE%.log";if(null!==e){const t=e.lastIndexOf(".");l=`${e}%DATE%`,t>0&&(l=`${e.slice(0,t)}%DATE%${e.slice(t)}`)}const n=logFileRotateDatePattern(t);return new WinstonDailyRotateFile({name:"dailyLogFile.info",datePattern:n,filename:l,maxsize:o})}return null!==e?new transports.File({name:"logFile.info",filename:e}):null}function generateLogger(e,l,t,o){const n=[new transports.Console({name:"console.info",level:internalLevel(e),format:format.colorize(),handleExceptions:!0,humanReadableUnhandledException:!0})],i=printf(e=>{if(null!==l)return l(e);if(null===e.optional||void 0===e.optional)return`${e.timestamp} ${e.level}: ${e.message}`;{let l=e.optional;return"object"==typeof l&&(l=null===l.name||void 0===l.name?JSON.stringify(l):`{${e.optional}}`),`${e.timestamp} ${e.level}: ${e.message} [Detail: ${l}]`}}),a=fileTransport(o.saveToFileName,o.isFileRotate,o.fileRotateType,o.fileRotateMaxSize);return null!==a&&n.push(a),createLogger({level:internalLevel(e),format:combine(colorize(),timestamp({format:"YYYY-MM-DD HH:mm:ss"}),i),transports:n,silent:t})}function optionalParser(e){const l={};return null!==e&&null!==e.cId&&void 0!==e.cId?l.cId=e.cId:null!==e&&null!==e.cid&&void 0!==e.cid&&(l.cId=e.cid),l}function internalLog(e,l){e.log({level:l.level,message:l.message,optional:l.optional})}async function parseLogMessage(e,l,t,o,n,i){const a=converseLeveValue(l);if(-1!==e.externalSource.levels.indexOf(a)){const l=a;let n=null,r=null,s=null;if(void 0!==t&&(n=t),null!==o&&void 0!==o){try{r=JSON.stringify(o)}catch(l){internalLog(e,{level:"error",message:`Fail To log ${o}`,optional:l})}const l=optionalParser(o);void 0!==l.cId&&(s=l.cId)}await i(l,n,r,s)}n()}function persistExternalSource(e,l,t,o){return new Promise(function(n,i){null!==e.externalSource&&null!==e.externalSource.callback&&null!==e.externalSource.connector?parseLogMessage(e,l,t,o,n,async function(l,t,o,n){try{await e.externalSource.callback(e.externalSource.connector,l,t,o,n)}catch(e){i(e)}}).then(()=>{n()}):n()})}function overrideExternalSource(e,l,t){const o={};return o.levels=e,o.connector=l,o.callback=t,o}function fileConfiguration(e){const l={saveToFileName:null,isFileRotate:DEFAULTISFILEROTATE,fileRotateType:DEFAULTFILEROTATETYPE,fileRotateMaxSize:DEFAULTFILEROTATEMAXSIZE};return null===e||void 0===e?l:(null!==e.saveToFileName&&void 0!==e.saveToFileName&&""!==e.saveToFileName&&(l.saveToFileName=e.saveToFileName),null!==e.isFileRotate&&"boolean"==typeof e.isFileRotate&&(l.isFileRotate=e.isFileRotate),null!==logFileRotateDatePattern(e.fileRotateType)&&(l.fileRotateType=e.fileRotateType),null!==e.fileRotateMaxSize&&void 0!==e.fileRotateMaxSize&&""!==e.fileRotateMaxSize&&(l.fileRotateMaxSize=e.fileRotateMaxSize),l)}function sourceConfiguration(e){let l=null;return null===e||void 0===e?l:l=overrideExternalSource(e.levels,e.connector,e.callback)}class Logger{constructor(e,l,t){this.silent=!1,this.externalDisplayFormat=null,this.fileConfig=null,this.externalSource=null,this.logger=null,this.setupLogConfig(e,l,t)}setupLogConfig(e,l,t){this.silent=!1,null!==e.silent&&void 0!==e.silent&&(this.silent=e.silent),this.externalDisplayFormat=null,null!==e.externalDisplayFormat&&void 0!==e.externalDisplayFormat&&(this.externalDisplayFormat=e.externalDisplayFormat),this.fileConfig=fileConfiguration(l),this.externalSource=sourceConfiguration(t),this.logger=generateLogger(e.level,this.externalDisplayFormat,this.silent,this.fileConfig)}log(e,l,t){return internalLog(this.logger,{level:e,message:l,optional:t}),new Promise(o=>{null!==this.externalSource&&persistExternalSource(this,e,l,t).then(()=>{o()}).catch(e=>{internalLog(this.logger,{level:"error",message:`Fail To log ${l} to External Source`,optional:e}),o()})})}}module.exports.Logger=Logger,module.exports.level=LOGLEVEL,module.exports.fileRotateType=LOGFILEROTATE;